/**
* Yahoo Stock Quote module
* This module allows you to add the Stock Quote from Yahoo Finance in a module position.
* Author: kksou
* Copyright (C) 2006-2008. kksou.com. All Rights Reserved
* Website: http://www.kksou.com/php-gtk2
* v1.5 September 1, 2008
*/

window.onload = yahoostock_prepareForm;
var timeout_id = 0;

function yahoostock_prepareForm() {
	if(!document.getElementById) {
		return;
	}
	if(!document.getElementById("yahoostock_form")) {
		return;
	}
	document.getElementById("yahoostock_form").onsubmit = function() {
		var data = "";
		for (var i=0; i<this.elements.length; i++) {
			data+= this.elements[i].name;
			data+= "=";
			data+= escape(this.elements[i].value);
			data+= "&";
		}
		data+= "process=1";
		//return !yahoostock_sendData(data);
		yahoostock_sendData(data);
		return false;
	};
}

function yahoostock_sendData(data) {
	if (timeout_id) {
		clearTimeout(timeout_id);
	}
	yahoostock_sendData2(data)
	var repeat = function() {
		yahoostock_sendData(data);
	};
	if (refresh_frequency!=0) {
		if (refresh_frequency<5) {
			refresh_frequency = 5;
		}
		timeout_id = setTimeout(repeat,refresh_frequency * 1000);
	}
}

function yahoostock_sendData2(data) {
	var request = yahoostock_getHTTPObject();
	if (request) {
		yahoostock_displayLoading(document.getElementById("yahoostock_loading"));
		request.onreadystatechange = function() {
			yahoostock_parseResponse(request);
		};
		url = yahoostock_lib_url+"?"+data
		+"&submit_button_label="+yahoostock_submit_button_label
		+"&use_curl="+yahoostock_use_curl
		+"&joomla_ver="+yahoostock_joomla_ver
		+"&style="+yahoostock_style;
		request.open( "GET", url, true );
		request.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT");
		request.send(null);
		return true;
	} else {
		return false;
	}
}

function yahoostock_parseResponse(request) {
	if (request.readyState == 4) {
		if (request.status == 200 || request.status == 304) {
			var container = document.getElementById("yahoostock_container");
			container.innerHTML = request.responseText;
			yahoostock_fadeUpErrors(container);
			yahoostock_prepareForm();
		}
	}
}

function yahoostock_getHTTPObject() {
	var xhr = false;
	if (window.XMLHttpRequest) {
		xhr = new XMLHttpRequest();
	} else if (window.ActiveXObject) {
		try {
			xhr = new ActiveXObject("Msxml2.XMLHTTP");
		} catch(e) {
			try {
				xhr = new ActiveXObject("Microsoft.XMLHTTP");
			} catch(e) {
				xhr = false;
			}
		}
	}
	return xhr;
}

function yahoostock_displayLoading(element) {
	//alert("yahoostock_show_progress = "+yahoostock_show_progress);
	if (yahoostock_show_progress==0) {
		return;
	}
	element.innerHTML = '<img src="'+yahoostock_progress_gif+'" alt="Loading..." />';
}

function yahoostock_displayLoading_v2(element) {
	var t1 = document.createElement("span");
	var text = document.createTextNode("Loading...");
	t1.appendChild(text);
	element.appendChild(t1);
}

function yahoostock_displayLoading_org(element) {
	var image = document.createElement("img");
	image.setAttribute("src", yahoostock_progress_gif);
	image.setAttribute("alt","Loading...");
	image.setAttribute("align","middle");
	element.appendChild(image);
}

function yahoostock_fadeUp(element,red,green,blue) {
	if (element.fade) {
		clearTimeout(element.fade);
	}
	element.style.backgroundColor = "rgb("+red+","+green+","+blue+")";
	if (red == 255 && green == 255 && blue == 255) {
		return;
	}
	var newred = red + Math.ceil((255 - red)/10);
	var newgreen = green + Math.ceil((255 - green)/10);
	var newblue = blue + Math.ceil((255 - blue)/10);
	var repeat = function() {
		fadeUp(element,newred,newgreen,newblue)
	};
	element.fade = setTimeout(repeat,100);
}

function yahoostock_fadeUpErrors(element) {
	var messages = element.getElementsByTagName("strong");
	for (var i=0; i<messages.length; i++) {
		if (messages[i].className == "error") {
			fadeUp(messages[i],255,153,153);
		}
	}
}